## apt-cacher-ng 0.4.6

=== Makefile ===
--- 
+++ 
@@ -1,3 +1,4 @@
+
 
 hints:
 	@echo To build apt-cacher-ng and/or helper programs, use:
@@ -10,12 +11,13 @@
 	@echo 'Parameters: DEBUG=1 -> creates a debug build'
 	@echo
 	@echo 'make clean   (deletes config and temporary files; call after parameter changes)'
+	@echo 'make gendbs  (fetches mirror data from the web, updates databases)'
 	@echo 
 
 
 all: acng in.acng acngfs
 
-CXXFLAGS ?= -g -Os -Wall
+CXXFLAGS ?= -g -Os -Wall -D_FILE_OFFSET_BITS=64
 CXXFLAGS += "-I$(CURDIR)/include"
 
 stampbuild-checkenv: checkenv.sh
@@ -31,10 +33,12 @@
 OBJSFS =  $(patsubst fs/%.cc,%.o, $(patsubst source/%.cc,%.o,$(SRCSFS)) )
 OBJSIN =  acbuf.o client.o
 
+DBTMP=dbgen/tmp
+
 distclean: clean
 
 clean:
-	rm -rf build apt-cacher-ng in.acng acngfs stamp-* $(OBJS) $(OBJSFS) $(OBJSIN)
+	rm -rf build apt-cacher-ng in.acng acngfs stamp-* $(OBJS) $(OBJSFS) $(OBJSIN) $(DBTMP)
 	rm -rf checkenv.cc checkenv.o stampbuild-* acsyscap.h getlongsize getlongsize.exe testendian testendian.exe checksuf checksuf.exe 
 
 acng: apt-cacher-ng
@@ -120,6 +124,26 @@
 
 # not calling it .depend, shouldn't be triggered on user's PC
 depend: $(SRCSALL) Makefile stampbuild-checkenv
-	$(CXX) -Iinclude -D_FILE_OFFSET_BITS=64 -MM $(SRCSALL) $(CXXFLAGS) $(CPPFLAGS) > .depend
+	$(CXX) -Iinclude -MM $(SRCSALL) $(CXXFLAGS) $(CPPFLAGS) > .depend
+
+gendbs:
+	mkdir -p $(DBTMP)
+	( w3m -dump http://www.iana.org/domains/root/db | perl -pe 'if(/^\.(\w\w)\s/) { $$_="http://".lc($$1).".archive.ubuntu.com/ubuntu\n";} else {undef $$_}';  wget -q -O- 'https://wiki.ubuntu.com/Mirrors?action=show&redirect=Archive' 'https://launchpad.net/ubuntu/+archivemirrors' ) | tr -d ' ' | tr -d '\t' | sed -e 's,",\n,g' | grep ^http | sort -u > $(DBTMP)/usnap
+	wget -q -O $(DBTMP)/dsnap 'http://cvs.debian.org/*checkout*/webwml/english/mirror/Mirrors.masterlist?rev=HEAD&cvsroot=webwml&content-type=text/plain'
+	md5sum $(DBTMP)/usnap > $(DBTMP)/sig-ubuntu
+	md5sum $(DBTMP)/dsnap > $(DBTMP)/sig-debian
+	cmp dbgen/sig-ubuntu $(DBTMP)/sig-ubuntu 2>/dev/null || cp $(DBTMP)/sig-ubuntu dbgen/sig-ubuntu 
+	cmp dbgen/sig-debian $(DBTMP)/sig-debian 2>/dev/null || cp $(DBTMP)/sig-debian dbgen/sig-debian
+	$(MAKE) $(MAKE_FLAGS) _dbconvert
+
+_dbconvert: conf/deb_mirrors.gz conf/debvol_mirrors.gz conf/ubuntu_mirrors
+
+conf/ubuntu_mirrors: dbgen/sig-ubuntu dbgen/ubuntuscan.sh
+	bash dbgen/ubuntuscan.sh $@ $(DBTMP)/usnap $(DBTMP)
+
+conf/debvol_mirrors.gz conf/deb_mirrors.gz: dbgen/sig-debian dbgen/debsplit.pl
+	perl dbgen/debsplit.pl < $(DBTMP)/dsnap
+	gzip -f -9 conf/deb_mirrors conf/debvol_mirrors
+
 
 -include .depend
