=== debian/changelog ===
apt-cacher-ng (0.4.6-1ubuntu1) lucid-proposed; urgency=low

  * convert package to 3.0 (quilt) format
  * update-manager -d requires access to the DevelReleaseAnnouncement
    accessing it with a ?lang=foo suffix.  Add this to the persistant
    files list.  LP: #601883.

 -- Andy Whitcroft <apw@canonical.com>  Mon, 05 Jul 2010 14:09:48 +0100

apt-cacher-ng (0.4.6-1) unstable; urgency=medium

  * New upstream version
    + decodes some special chars for local storage (closes: #573222),
      affected users should refer to README.Debian for instructions about
      correction of the bad filenames

 -- Eduard Bloch <blade@debian.org>  Wed, 10 Mar 2010 22:12:57 +0100

apt-cacher-ng (0.4.5-1) unstable; urgency=low

  * New upstream release
    + documented DnsCacheSeconds (Ubuntu bug 530524)
    + Added simple implementation of SOAP request forwarding for PTS 
      access (closes: #453277)
    + Typo fix in userinfo.html (closes: #572171)

 -- Eduard Bloch <blade@debian.org>  Wed, 03 Mar 2010 21:31:40 +0100

apt-cacher-ng (0.4.4-1) unstable; urgency=low

  * New upstream release
    + adds a more meaningful message for incorrect backend mirror
      settings (closes: #549222)
    + internal improvements, still hunting bug #558133
  * init script and policy compliancy updates

 -- Eduard Bloch <blade@debian.org>  Sun, 21 Feb 2010 23:04:58 +0100

apt-cacher-ng (0.4.3-1) unstable; urgency=medium

  * Support for new dpkg v3 source formats

 -- Eduard Bloch <blade@debian.org>  Sun, 06 Dec 2009 12:22:36 +0100

apt-cacher-ng (0.4.2-1) unstable; urgency=medium

  * New upstream release
    + little documentation fixes, corrected format of the import howto and
      explained the results of the procedure (closes: #559075)
  * Fix repeated setup on package upgrade (closes: #559024). Also tries to
    keep backend config files if the user maintained them manually before but
    they could not generated at all via automated setup.

 -- Eduard Bloch <blade@debian.org>  Tue, 01 Dec 2009 21:52:29 +0100

apt-cacher-ng (0.4.1-1) unstable; urgency=low

  [ Jonathan Wiltshire <debian@jwiltshire.org.uk> ]
  * Debconf templates and debian/control reviewed by the debian-l10n-
    english team as part of the Smith review project. Closes: #552017
  * Debconf translation updates:
    - Russian (closes: #545211)
    - Finnish (closes: #552253)
    - Czech (closes: #552452)
    - Basque (closes: #552806)
    - Japanese (closes: #553029)
    - Portugese (closes: #554119)
    - Swedish (closes: #554137)
    - French (closes: #554366)
    - Galician (closes: #554634)

  [ Eduard Bloch ]
  * debconf update, reduced query to one dialog
  * Debconf translation updates from contributors:
    - Italian (closes: #556109)
    - Spanish (closes: #538106)
  * New upstream release:
    + enabled resuming of downloads of incomplete files where the conditions
      allow that without nasty side effects (closes: #544205)
    + passing HTTP redirection target through to user (closes: #556234)
  * Unconfuse crontab expiration script when BindAdress contains multiple
    entries (patch by Hellekin O\. Wolf, closes: #554707)
 
 -- Eduard Bloch <blade@debian.org>  Sun, 22 Nov 2009 19:06:32 +0100

apt-cacher-ng (0.4-1) unstable; urgency=low

  * New upstream release
    + Fixes thread leak due to race condition, based on patch
      from Alexander Inyukhin (thanks, closes: #530440)

 -- Eduard Bloch <blade@debian.org>  Tue, 26 May 2009 00:03:20 +0200

apt-cacher-ng (0.3.12-1) unstable; urgency=low

  * New upstream release
    + more reliable closing of file handles (might solve #529744)
    + reveals origin of 40x HTTP errors to the user (for #530021)
  * verbose Debconf configuration for automated backend setup which repeatedly
    confused some users in the past (closes: #530021). Deprecates the
    truncate-and-reconfigure trick.

 -- Eduard Bloch <blade@debian.org>  Mon, 25 May 2009 01:21:29 +0200

apt-cacher-ng (0.3.11-1) unstable; urgency=low

  * New upstream release
  * Log file removal on purge (closes: #527378)

 -- Eduard Bloch <blade@debian.org>  Sat, 09 May 2009 19:50:34 +0200

apt-cacher-ng (0.3.10-1) unstable; urgency=high

  * New upstream release
    + fixing a subtle change in 0.3.9 which breaks import function and might
    cause cache damage for users who manually run expiration with data
    checksumming (many thanks to Petra Ruebe-Pugliese, closes: #526956)

 -- Eduard Bloch <blade@debian.org>  Mon, 04 May 2009 23:02:41 +0200

apt-cacher-ng (0.3.9-1) unstable; urgency=medium

  * New upstream release
  * Moved service disabling check to the correct place (closes: #523290)

 -- Eduard Bloch <blade@debian.org>  Tue, 21 Apr 2009 23:55:16 +0200

apt-cacher-ng (0.3.8-1) unstable; urgency=medium

  * New upstream release
  * Fixed init script deactivation (closes: #522186)

 -- Eduard Bloch <blade@debian.org>  Sat, 04 Apr 2009 23:03:52 +0200

apt-cacher-ng (0.3.7-1) unstable; urgency=medium

  * New upstream release
    + fixes debian-volatile confusion, updated the mirror list (closes: #522239)
    + added some documentation and a documentation reference to the error
      messages for the busy port condition (closes: #522178)
  * mirror picker improvements: considering ftp sources correctly, removing
    duplicate lines in backend files
  * added support for the init script deactivation with an environment
    variable (closes: #522186)

 -- Eduard Bloch <blade@debian.org>  Fri, 03 Apr 2009 22:53:25 +0200

apt-cacher-ng (0.3.6-1) unstable; urgency=low

  * New upstream release with minor speedups
  * Fixed new bashisms in the init script (closes: #521465)

 -- Eduard Bloch <blade@debian.org>  Fri, 27 Mar 2009 22:26:18 +0100

apt-cacher-ng (0.3.5-2) unstable; urgency=low

  * Added ftp: as possible pattern when looking for good mirrors in
    sources.list for backend definition creation (now really closes: #520824)

 -- Eduard Bloch <blade@debian.org>  Thu, 26 Mar 2009 23:59:36 +0100


