## apt-cacher-ng 0.5.1

=== Makefile ===
--- 
+++ 
@@ -17,21 +17,29 @@
 
 all: acng in.acng acngfs
 
-CXXFLAGS ?= -g -Os -Wall -D_FILE_OFFSET_BITS=64
-CXXFLAGS += "-I$(CURDIR)/include"
+# no presets from environment? Remember some optimization flags then...
+ifeq ($(CXXFLAGS),)
+__acng_opt_flags=-O2 -Wall
+endif
 
+# some useful or required flags
+CXXFLAGS += -D_FILE_OFFSET_BITS=64 "-I$(CURDIR)/include"
+
+configure: stampbuild-checkenv
 stampbuild-checkenv: checkenv.sh
 	@sh checkenv.sh $(CXX) $(CXXFLAGS) > acsyscap.h
 	@touch $@
 
+acsyscap.h: stampbuild-checkenv
+
 SRCS = $(wildcard source/*.cc)
-SRCSFS = source/header.cc fs/httpfs.cc source/lockable.cc source/meta.cc source/acbuf.cc source/rechecks.cc source/caddrinfo.cc
+SRCSFS = source/header.cc fs/httpfs.cc source/lockable.cc source/meta.cc source/acbuf.cc source/caddrinfo.cc source/acfg_defaults.cc source/acfg.cc source/filereader.cc source/md5.cc source/sha1.cc
 SRCSIN = source/acbuf.cc client/client.cc
 SRCSALL = $(SRCS) client/client.cc fs/httpfs.cc
 
 OBJS =  $(patsubst source/%.cc,%.o,$(SRCS))
 OBJSFS =  $(patsubst fs/%.cc,%.o, $(patsubst source/%.cc,%.o,$(SRCSFS)) )
-OBJSIN =  acbuf.o client.o
+OBJSIN =  client.o
 
 DBTMP=dbgen/tmp
 
@@ -39,11 +47,13 @@
 
 clean:
 	rm -rf build apt-cacher-ng in.acng acngfs stamp-* $(OBJS) $(OBJSFS) $(OBJSIN) $(DBTMP)
-	rm -rf checkenv.cc checkenv.o stampbuild-* acsyscap.h getlongsize getlongsize.exe testendian testendian.exe checksuf checksuf.exe 
+	rm -rf checkenv.cc checkenv.o checkenv_testbin checkenv_testbin.exe stampbuild-* acsyscap.h getlongsize getlongsize.exe testendian testendian.exe checksuf checksuf.exe 
 
 acng: apt-cacher-ng
 
 ifeq ($(DEBUG),)
+
+CXXFLAGS += $(__acng_opt_flags)
 
 # small build, even replacing libstdc++ with supc++ and gcc linking
 in.acng: $(OBJSIN)
@@ -52,12 +62,11 @@
 
 apt-cacher-ng: $(OBJS)
 	$(CXX) -o $@ $(OBJS) -lpthread $(LDFLAGS) -lz -lbz2
-	@-test -d ../unstripped && cp $@ ../unstripped/$@.$$(dpkg-parsechangelog |grep ^Version: | cut -f2 -d' ') || true
-	strip $@
+	@-test -d ../unstripped && cp $@ ../unstripped/$@.$$(dpkg-parsechangelog |grep ^Version: | cut -f2 -d' ') && strip $@ || true
 
 else
 
-CXXFLAGS += -DDEBUG -Wall
+CXXFLAGS += -DDEBUG -g -Wall -O0
 
 in.acng: $(OBJSIN) $(OBJS)
 	$(CXX) -o $@ acbuf.o client.o acfg.o filereader.o meta.o md5.o sha1.o aclogger.o -lz -lbz2 -Wl,--as-needed
@@ -67,10 +76,11 @@
 	$(CXX) -o $@ $(OBJS) -lpthread $(LDFLAGS) -lz -lbz2
 endif
 
+FUSECFLAGS=$(shell pkg-config --cflags fuse)
+FUSELFLAGS=$(shell pkg-config --libs fuse)
 acngfs: $(OBJSFS)
-	$(CXX) -o acngfs $(OBJSFS) -Wl,--as-needed `pkg-config fuse --libs`
-	@-test -d ../unstripped && cp $@ ../unstripped/$@.$$(dpkg-parsechangelog |grep ^Version: | cut -f2 -d' ') || true
-	strip $@
+	$(CXX) -o acngfs $(OBJSFS) -Wl,--as-needed $(FUSELFLAGS) -lz -lbz2
+	@-test -d ../unstripped && cp $@ ../unstripped/$@.$$(dpkg-parsechangelog |grep ^Version: | cut -f2 -d' ') && strip $@ || true
 
 doc: doc/src/README.but doc/src/manpage.but doc/src/acngfs.but
 	mkdir -p doc/.build doc/html doc/man
@@ -83,8 +93,8 @@
 
 fixversion: VERSION
 	mkdir -p build/tmp
-	sed -e 's,^.*define.*ACVERSION.*,#define ACVERSION "$(VERSION)",' < include/acfg.h > build/tmp/hh
-	cmp include/acfg.h build/tmp/hh || cp build/tmp/hh include/acfg.h
+	sed -e 's,^.*define.*ACVERSION.*,#define ACVERSION "$(VERSION)",' < include/config.h > build/tmp/hh
+	cmp include/config.h build/tmp/hh || cp build/tmp/hh include/config.h
 
 VERSION=$(shell cat VERSION)
 DISTNAME=apt-cacher-ng-$(VERSION)
@@ -120,30 +130,49 @@
 $(OBJS) client.o: %.o: %.cc stampbuild-checkenv
 	$(CXX) -c $(CXXFLAGS) $< -o $@
 httpfs.o: fs/httpfs.cc stampbuild-checkenv
-	$(CXX) -c $(CXXFLAGS) `pkg-config fuse --cflags`  $< -o $@
+	$(CXX) -c $(CXXFLAGS) $(FUSECFLAGS)  $< -o $@
 
 # not calling it .depend, shouldn't be triggered on user's PC
 depend: $(SRCSALL) Makefile stampbuild-checkenv
 	$(CXX) -Iinclude -MM $(SRCSALL) $(CXXFLAGS) $(CPPFLAGS) > .depend
 
-gendbs:
+gendbs: get_deb_input get_ubu_input get_cyg_input
+	$(MAKE) $(MAKE_FLAGS) _dbconvert
+
+get_deb_input:
+	mkdir -p $(DBTMP)
+	wget -q -O $(DBTMP)/dsnap 'http://cvs.debian.org/*checkout*/webwml/english/mirror/Mirrors.masterlist?rev=HEAD&cvsroot=webwml&content-type=text/plain'
+	md5sum $(DBTMP)/dsnap > $(DBTMP)/sig-debian
+	cmp dbgen/sig-debian $(DBTMP)/sig-debian 2>/dev/null || cp $(DBTMP)/sig-debian dbgen/sig-debian
+
+get_ubu_input:
 	mkdir -p $(DBTMP)
 	( w3m -dump http://www.iana.org/domains/root/db | perl -pe 'if(/^\.(\w\w)\s/) { $$_="http://".lc($$1).".archive.ubuntu.com/ubuntu\n";} else {undef $$_}';  wget -q -O- 'https://wiki.ubuntu.com/Mirrors?action=show&redirect=Archive' 'https://launchpad.net/ubuntu/+archivemirrors' ) | tr -d ' ' | tr -d '\t' | sed -e 's,",\n,g' | grep ^http | sort -u > $(DBTMP)/usnap
-	wget -q -O $(DBTMP)/dsnap 'http://cvs.debian.org/*checkout*/webwml/english/mirror/Mirrors.masterlist?rev=HEAD&cvsroot=webwml&content-type=text/plain'
 	md5sum $(DBTMP)/usnap > $(DBTMP)/sig-ubuntu
-	md5sum $(DBTMP)/dsnap > $(DBTMP)/sig-debian
 	cmp dbgen/sig-ubuntu $(DBTMP)/sig-ubuntu 2>/dev/null || cp $(DBTMP)/sig-ubuntu dbgen/sig-ubuntu 
-	cmp dbgen/sig-debian $(DBTMP)/sig-debian 2>/dev/null || cp $(DBTMP)/sig-debian dbgen/sig-debian
-	$(MAKE) $(MAKE_FLAGS) _dbconvert
 
-_dbconvert: conf/deb_mirrors.gz conf/debvol_mirrors.gz conf/ubuntu_mirrors
+get_cyg_input:
+	mkdir -p $(DBTMP)
+	wget -q -O- http://cygwin.com/mirrors.lst | grep ^http | cut -f1 -d\; >$(DBTMP)/mirrors.http
+	md5sum $(DBTMP)/mirrors.http > $(DBTMP)/sig-cygwin
+	cmp dbgen/sig-cygwin $(DBTMP)/sig-cygwin 2>/dev/null || cp $(DBTMP)/sig-cygwin dbgen/sig-cygwin
+
+_dbconvert: conf/deb_mirrors.gz conf/debvol_mirrors.gz conf/ubuntu_mirrors conf/cygwin_mirrors
 
 conf/ubuntu_mirrors: dbgen/sig-ubuntu dbgen/ubuntuscan.sh
 	bash dbgen/ubuntuscan.sh $@ $(DBTMP)/usnap $(DBTMP)
+
+conf/cygwin_mirrors: Makefile dbgen/sig-cygwin
+	cp $(DBTMP)/mirrors.http conf/cygwin_mirrors
 
 conf/debvol_mirrors.gz conf/deb_mirrors.gz: dbgen/sig-debian dbgen/debsplit.pl
 	perl dbgen/debsplit.pl < $(DBTMP)/dsnap
 	gzip -f -9 conf/deb_mirrors conf/debvol_mirrors
 
+# help the automatic dependency tracking
+acsyscap.h: stampbuild-checkenv
+include/../acsyscap.h: acsyscap.h
+client/../acsyscap.h: acsyscap.h
+fs/../acsyscap.h: acsyscap.h
 
 -include .depend
