## apt-cacher-ng 0.5.6

=== Makefile ===
--- 
+++ 
@@ -47,7 +47,7 @@
 
 clean:
 	rm -rf build apt-cacher-ng in.acng acngfs stamp-* $(OBJS) $(OBJSFS) $(OBJSIN) $(DBTMP)
-	rm -rf checkenv.cc checkenv.o checkenv_testbin checkenv_testbin.exe stampbuild-* acsyscap.h getlongsize getlongsize.exe testendian testendian.exe checksuf checksuf.exe 
+	rm -rf checkenv.cc checkenv.o checkenv_testbin checkenv_testbin.exe stampbuild-* acsyscap.h getlongsize getlongsize.exe testendian testendian.exe checksuf checksuf.exe link.flags
 
 acng: apt-cacher-ng
 
@@ -61,25 +61,26 @@
 	strip $@
 
 apt-cacher-ng: $(OBJS)
-	$(CXX) -o $@ $(OBJS) -lpthread $(LDFLAGS) -lz -lbz2
-	@-test -d ../unstripped && cp $@ ../unstripped/$@.$$(dpkg-parsechangelog |grep ^Version: | cut -f2 -d' ') && strip $@ || true
+	$(CXX) $(CXXFLAGS) -o $@ $(OBJS) -lpthread $(LDFLAGS) `cat link.flags`
+	@-test -d ../unstripped && cp $@ ../unstripped/$@.$$(dpkg-parsechangelog |grep ^Version: | cut -f2 -d' ') || true
+#@-test -d ../unstripped && cp $@ ../unstripped/$@.$$(dpkg-parsechangelog |grep ^Version: | cut -f2 -d' ') && strip $@ || true
 
 else
 
 CXXFLAGS += -DDEBUG -g -Wall -O0
 
 in.acng: $(OBJSIN) $(OBJS)
-	$(CXX) -o $@ acbuf.o client.o acfg.o filereader.o meta.o md5.o sha1.o aclogger.o -lz -lbz2 -Wl,--as-needed
+	$(CXX) -o $@ acbuf.o client.o acfg.o filereader.o meta.o md5.o sha1.o aclogger.o -Wl,--as-needed
 	strip $@
 
 apt-cacher-ng: $(OBJS)
-	$(CXX) -o $@ $(OBJS) -lpthread $(LDFLAGS) -lz -lbz2
+	$(CXX) -o $@ $(OBJS) -lpthread $(LDFLAGS) `cat link.flags`
 endif
 
 FUSECFLAGS=$(shell pkg-config --cflags fuse)
 FUSELFLAGS=$(shell pkg-config --libs fuse)
 acngfs: $(OBJSFS)
-	$(CXX) -o acngfs $(OBJSFS) -Wl,--as-needed $(FUSELFLAGS) -lz -lbz2
+	$(CXX) -o acngfs $(OBJSFS) -Wl,--as-needed $(FUSELFLAGS) `cat link.flags`
 	@-test -d ../unstripped && cp $@ ../unstripped/$@.$$(dpkg-parsechangelog |grep ^Version: | cut -f2 -d' ') && strip $@ || true
 
 doc: doc/src/README.but doc/src/manpage.but doc/src/acngfs.but
@@ -113,6 +114,7 @@
 	rm -rf tmp
 	test -e /etc/debian_version && ln -f ../$(DISTNAME).tar.gz ../$(DEBSRCNAME) || true
 	test -e ../tarballs && ln -f ../$(DISTNAME).tar.gz ../tarballs/$(DEBSRCNAME) || true
+	test -e ../build-area && ln -f ../$(DISTNAME).tar.gz ../build-area/$(DEBSRCNAME) || true
 
 tarball-remove:
 	rm -f ../$(DISTNAME).tar.gz ../tarballs/$(DEBSRCNAME) ../$(DEBSRCNAME) ../build-area/$(DEBSRCNAME)
@@ -121,6 +123,9 @@
 release: tarball
 	svn ci
 	svn cp $(SVNBASE)/trunk $(SVNBASE)/tags/release_$(shell cat VERSION)
+
+unrelease: tarball-remove
+	svn rm $(SVNBASE)/tags/release_$(shell cat VERSION)
 
 #.PHONY: install all doc
 
@@ -136,7 +141,8 @@
 depend: $(SRCSALL) Makefile stampbuild-checkenv
 	$(CXX) -Iinclude -MM $(SRCSALL) $(CXXFLAGS) $(CPPFLAGS) > .depend
 
-gendbs: get_deb_input get_ubu_input get_cyg_input
+# first get and check data, then replace the mirror output lists but for some sources do it only when needed 
+gendbs: get_deb_input get_ubu_input
 	$(MAKE) $(MAKE_FLAGS) _dbconvert
 
 get_deb_input:
@@ -151,23 +157,22 @@
 	md5sum $(DBTMP)/usnap > $(DBTMP)/sig-ubuntu
 	cmp dbgen/sig-ubuntu $(DBTMP)/sig-ubuntu 2>/dev/null || cp $(DBTMP)/sig-ubuntu dbgen/sig-ubuntu 
 
-get_cyg_input:
-	mkdir -p $(DBTMP)
-	wget -q -O- http://cygwin.com/mirrors.lst | grep ^http | cut -f1 -d\; >$(DBTMP)/mirrors.http
-	md5sum $(DBTMP)/mirrors.http > $(DBTMP)/sig-cygwin
-	cmp dbgen/sig-cygwin $(DBTMP)/sig-cygwin 2>/dev/null || cp $(DBTMP)/sig-cygwin dbgen/sig-cygwin
-
-_dbconvert: conf/deb_mirrors.gz conf/debvol_mirrors.gz conf/ubuntu_mirrors conf/cygwin_mirrors
+_dbconvert: conf/deb_mirrors.gz conf/debvol_mirrors.gz conf/ubuntu_mirrors conf/cygwin_mirrors conf/archlx_mirrors
 
 conf/ubuntu_mirrors: dbgen/sig-ubuntu dbgen/ubuntuscan.sh
 	bash dbgen/ubuntuscan.sh $@ $(DBTMP)/usnap $(DBTMP)
 
 conf/cygwin_mirrors: Makefile dbgen/sig-cygwin
-	cp $(DBTMP)/mirrors.http conf/cygwin_mirrors
+	wget -q -O- http://cygwin.com/mirrors.lst | grep ^http | cut -f1 -d\; > conf/cygwin_mirrors
+
+conf/archlx_mirrors: Makefile
+	wget -q --no-check-certificate  -O- 'https://archlinux.de/?page=MirrorStatus' | grep nofollow | cut -f2 -d'"'  | grep ^http > conf/archlx_mirrors
 
 conf/debvol_mirrors.gz conf/deb_mirrors.gz: dbgen/sig-debian dbgen/debsplit.pl
 	perl dbgen/debsplit.pl < $(DBTMP)/dsnap
 	gzip -f -9 conf/deb_mirrors conf/debvol_mirrors
+
+.PHONY: conf/archlx_mirrors conf/cygwin_mirrors
 
 # help the automatic dependency tracking
 acsyscap.h: stampbuild-checkenv
